-- Scope

property("Axes", COLOUR, 255,0,0) -- Axes colour
property("Wave", COLOUR, 0,255,0) -- Wave colour
property("Background", COLOUR, 0,0,0) -- Background colour
property("Phase",INTEGER,0,0,359) -- The Phase of the effect

function pixel(frame, x, y)
    out = Background -- Default output colour to background
    if y == height/2 then -- Draw x axis
        out = Axes -- output colour is axes colour
    end
    if x == 0 then -- Draw y axis
        out = Axes -- output colour is axes colour
    end
    t = frame/frames -- determine fraction through effect
    if round((math.sin(((x/width)+t+(Phase/360))*2*math.pi)/2)*height+((height-1)/2)) == y then -- check whether the pixel is on the sine wave
        out = Wave -- output colour is wave colour
    end
    return out -- output the appropriate colour
end

-- Simple rounding function to round to nearest integer
function round(num)
  local mult = 10^(0)
  return math.floor(num * mult + 0.5) / mult
end

--[[
Copyright 2016 Pharos Architectural Controls Limited. All rights reserved.

This sample content is made freely available for illustrative purposes only. Pharos Architectural Controls grants a non-exclusive copyright licence to use this sample content from which you can generate content tailored to your own specific needs for use with products from Pharos Architectural Controls. This sample content has not been thoroughly tested under all conditions and Pharos Architectural Controls cannot guarantee reliability or serviceability.

This sample content is provided "as is" without warranties of any kind. The implied warranties of non-infringement, merchantability and fitness for a particular purpose are expressly disclaimed. In no event shall Pharos Architectural Controls be liable to any party for direct, indirect, incidental or consequential damages arising from the use of this sample content.

For further information please contact support@pharoscontrols.com.
--]]